"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request-promise");
class RESTUtil {
    // https://github.com/request/request-promise
    constructor() { }
    async sfdcGet(url, authtoken) {
        let response;
        const options = {
            uri: url,
            headers: {
                'User-Agent': 'Request-Promise',
                Authorization: 'Bearer ' + authtoken
            },
            json: true
        };
        await request(options)
            .then(body => { response = body; })
            .catch(err => { response = { err: err.toString() }; });
        return response;
    }
    async sfdcSoapPost(url, action, bdy) {
        console.log(`body: ${bdy}`);
        let response;
        const options = {
            method: 'POST',
            uri: url,
            headers: {
                'User-Agent': 'Request-Promise',
                'Content-Type': 'text/xml',
                SoapAction: action
            },
            body: bdy
        };
        await request(options)
            .then(body => { response = body; })
            .catch(err => { response = { err: err.toString() }; });
        return response;
    }
}
exports.RESTUtil = RESTUtil;
//# sourceMappingURL=RestUtils.js.map