"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const jsforce = require("jsforce");
const connectionInfo_1 = require("../helper/connectionInfo");
class SfdcLogin {
    constructor(orgName) {
        this.orgName = orgName;
    }
    async sfdcLogin(loginfile) {
        const loginData = fs.readFileSync(loginfile, 'utf8');
        const loginInfo = JSON.parse(loginData)[this.orgName];
        // console.log(`loginfile: ${loginData}`);
        const sfdcconn = new jsforce.Connection({
            // you can change loginUrl to connect to sandbox or pre-release env.
            // loginUrl : 'https://login.salesforce.com'
            loginUrl: loginInfo.loginUrl
        });
        const username = loginInfo.username;
        const password = `${loginInfo.password}${loginInfo.securityToken}`;
        // console.log(`password: ${password}`);
        // console.log(`**** Login for ${username} ****`);
        let loggedInUserInfo;
        await sfdcconn.login(username, password, (err, userInfo) => {
            // console.log('**** Inside login ****');
            if (err) {
                return console.error(err);
            }
            // Now you can get the access token and instance URL information.
            // Save them to establish connection next time.
            // console.log(sfdcconn.accessToken);
            // console.log(sfdcconn.instanceUrl);
            // logged in user property
            // console.log('User ID: ' + userInfo.id);
            // console.log('Org ID: ' + userInfo.organizationId);
            loggedInUserInfo = userInfo;
        });
        // console.log(`**** LoggedInUserInfo: ${JSON.stringify(loggedInUserInfo, null, 2)} ****`);
        return new connectionInfo_1.ConnectionInfo(sfdcconn, loggedInUserInfo);
    }
}
exports.SfdcLogin = SfdcLogin;
//# sourceMappingURL=sfdcLogin.js.map